---
title: GLSL Shaders
slug: Games/Techniques/3D_on_the_web/GLSL_Shaders
tags:
  - Beginner
  - GLSL
  - OpenGL
  - Shader
  - texture shader
  - three.js
  - vertex shader
---
<div>{{GamesSidebar}}</div>

<p class="summary"><span class="seosummary">Shaders use GLSL (</span><span class="ILfuVd">OpenGL Shading Language</span>)<span class="seosummary">, a special OpenGL Shading Language with syntax similar to C. GLSL is executed directly by the graphics pipeline. There are two types of shaders: Vertex Shaders and Fragment (Pixel) Shaders. Vertex Shaders transform shape positions into 3D drawing coordinates. Fragment Shaders compute the renderings of a shape's colors and other attributes.</span></p>

<p>GLSL is not as intuitive as JavaScript. GLSL is strongly typed and there is a lot of math involving vectors and matrices. It can get very complicated — very quickly. In this article we will make a simple code example that renders a cube. To speed up the background code we will be using the Three.js API.</p>

<p>As you may remember from the <a href="/en-US/docs/Games/Techniques/3D_on_the_web/Basic_theory">basic theory</a> article, a vertex is a point in a 3D coordinate system. Vertices may, and usually do, have additional properties. The 3D coordinate system defines space and the vertices help define shapes in that space.</p>

<h2 id="shader_types">Shader types</h2>

<p>A shader is essentially a function required to draw something on the screen. Shaders run on a <a href="https://en.wikipedia.org/wiki/GPU">GPU</a> (graphics processing unit), which is optimized for such operations. Using a GPU to deal with shaders offloads some of the number crunching from the CPU. This allows the CPU to focus its processing power on other tasks, like executing code.</p>

<h3 id="vertex_shader">Vertex shaders</h3>

<p>Vertex shaders manipulate coordinates in a 3D space and are called once per vertex. The purpose of the vertex shader is to set up the <code>gl_Position</code> variable — this is a special, global, and built-in GLSL variable. <code>gl_Position</code> is used to store the position of the current vertex.</p>

<p>The <code>void main()</code> function is a standard way of defining the <code>gl_Position</code> variable. Everything inside  <code>void main()</code> will be executed by the vertex shader.  A vertex shader yields a variable containing how to project a vertex's position in 3D space onto a 2D screen.</p>

<h3 id="fragment_shader">Fragment shaders</h3>

<p>Fragment (or texture) shaders define RGBA (red, green, blue, alpha) colors for each pixel being processed — a single fragment shader is called once per pixel. The purpose of the fragment shader is to set up the <code>gl_FragColor</code> variable. <code>gl_FragColor</code> is a built-in GLSL variable like <code>gl_Position</code>.</p>

<p>The calculations result in a variable containing the information about the RGBA color.</p>

<h2 id="demo">Demo</h2>

<p>Let's build a simple demo to explain those shaders in action. Be sure to read <a href="/en-US/docs/Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_Three.js">Three.js tutorial</a> first to grasp the concept of the scene, its objects, and materials.</p>

<div class="note">
<p><strong>Note</strong>: Remember that you don't have to use Three.js or any other library to write your shaders — pure <a href="/en-US/docs/Web/API/WebGL_API">WebGL</a> (Web Graphics Library) is more than enough. We've used Three.js here to make the background code a lot simpler and clearer to understand, so you can just focus on the shader code. Three.js and other 3D libraries abstract a lot of things for you — if you wanted to create such an example in raw WebGL, you'd have to write a lot of extra code to actually make it work.</p>
</div>

<h3 id="Environment_setup">Environment setup</h3>

<p>To start with the WebGL shaders you don't need much. You should:</p>

<ul>
 <li>Make sure you are using a modern browser with good <a href="/en-US/docs/Web/API/WebGL_API">WebGL</a> support, such as the latest Firefox or Chrome.</li>
 <li>Create a directory to store your experiments in.</li>
 <li>Save a copy of the <a href="https://threejs.org/build/three.min.js">latest minimized Three.js library</a> inside your directory.</li>
</ul>

<h3 id="HTML_structure">HTML structure</h3>

<p>Here's the HTML structure we will use.</p>

<pre class="brush: html notranslate">&lt;!DOCTYPE html&gt;
&lt;html&gt;
&lt;head&gt;
	&lt;meta charset="utf-8"&gt;
	&lt;title&gt;MDN Games: Shaders demo&lt;/title&gt;
	&lt;style&gt;
		body { margin: 0; padding: 0; font-size: 0; }
		canvas { width: 100%; height: 100%; }
	&lt;/style&gt;
	&lt;script src="three.min.js"&gt;&lt;/script&gt;
&lt;/head&gt;
&lt;body&gt;
  &lt;script id="vertexShader" type="x-shader/x-vertex"&gt;
	// vertex shader's code goes here
  &lt;/script&gt;
  &lt;script id="fragmentShader" type="x-shader/x-fragment"&gt;
	// fragment shader's code goes here
  &lt;/script&gt;
  &lt;script&gt;
	// scene setup goes here
  &lt;/script&gt;
&lt;/body&gt;
&lt;/html&gt;
</pre>

<p>It contains some basic information like the document {{htmlelement("title")}}, and some CSS to set the <code>width</code> and <code>height</code> of the {{htmlelement("canvas")}} element that Three.js will insert on the page to be the full size of the viewport. The {{htmlelement("script")}} element in the {{htmlelement("head")}} includes the Three.js library in the page; we will write our code into three script tags in the {{htmlelement("body")}} tag:</p>

<ol>
 <li>The first one will contain the vertex shader.</li>
 <li>The second one will contain the fragment shader.</li>
 <li>The third one will contain the actual JavaScript code generating the scene.</li>
</ol>

<p>Before reading on, copy this code to a new text file and save it in your working directory as <code>index.html</code>. We'll create a scene featuring a simple cube in this file to explain how the shaders work.</p>

<h3 id="The_cubes_source_code">The cube's source code</h3>

<p>Instead of creating everything from scratch we can reuse the <a href="/en-US/docs/Games/Techniques/3D_on_the_web/Building_up_a_basic_demo_with_Three.js">Building up a basic demo with Three.js</a> source code of the cube. Most of the components like the renderer, camera, and lights will stay the same, but instead of the basic material we will set the cube's color and position using shaders.</p>

<p>Go to the <a href="https://github.com/end3r/MDN-Games-3D/blob/gh-pages/Three.js/cube.html">cube.html file on GitHub</a>, copy all the JavaScript code from inside the second {{htmlelement("script")}} element, and paste it into the third <code>&lt;script&gt;</code> element of the current example. Save and load <code>index.html</code> in your browser — you should see a blue cube.</p>

<h3 id="The_vertex_shader_code">The vertex shader code</h3>

<p>Let's continue by writing a simple vertex shader — add the code below inside the body's first <code>&lt;script&gt;</code> tag:</p>

<pre class="brush: glsl notranslate">void main() {
	gl_Position = projectionMatrix * modelViewMatrix * vec4(position.x+10.0, position.y, position.z+5.0, 1.0);
}
</pre>

<p>The resulting <code>gl_Position</code> is calculated by multiplying the model-view and the projection matrices by each vector to get the final vertex position, in each case.</p>

<div class="note">
<p><strong>Note</strong>: You can learn more about <em>model</em>, <em>view</em>, and <em>projection transformations</em> from the <a href="/en-US/docs/Games/Techniques/3D_on_the_web/Basic_theory#Vertex_processing">vertex processing paragraph</a>, and you can also check out the links at the end of this article to learn more about it.</p>
</div>

<p>Both <code>projectionMatrix</code> and <code>modelViewMatrix</code> are provided by Three.js and the vector is passed with the new 3D position, which results in the original cube moving 10 units along the <code>x</code> axis and 5 units along the <code>z</code> axis, translated via a shader. We can ignore the fourth parameter and leave it with the default <code>1.0</code> value; this is used to manipulate the clipping of the vertex position in the 3D space, but we don't need in our case.</p>

<h3 id="The_texture_shader_code">The texture shader code</h3>

<p>Now we'll add the texture shader to the code — add the code below to the body's second <code>&lt;script&gt;</code> tag:</p>

<pre class="brush: glsl notranslate">void main() {
	gl_FragColor = vec4(0.0, 0.58, 0.86, 1.0);
}
</pre>

<p>This will set an RGBA color to recreate the current light blue one — the first three float values (ranging from <code>0.0</code> to <code>1.0</code>) represent the red, green, and blue channels while the fourth one is the alpha transparency (ranging from <code>0.0</code> — fully transparent — to 1.0 — fully opaque).</p>

<h3 id="Applying_the_shaders">Applying the shaders</h3>

<p>To actually apply the newly created shaders to the cube, comment out the <code>basicMaterial</code> definition first:</p>

<pre class="brush: js notranslate">// var basicMaterial = new THREE.MeshBasicMaterial({color: 0x0095DD});
</pre>

<p>Then, create the <a href="http://threejs.org/docs/#Reference/Materials/ShaderMaterial"><code>shaderMaterial</code></a>:</p>

<pre class="brush: js notranslate">var shaderMaterial = new THREE.ShaderMaterial( {
	vertexShader: document.getElementById( 'vertexShader' ).textContent,
	fragmentShader: document.getElementById( 'fragmentShader' ).textContent
});
</pre>

<p>This shader material takes the code from the scripts and applies it to the object the material is assigned to.</p>

<p>Then, in the line that defines the cube we need to replace the <code>basicMaterial</code>:</p>

<pre class="brush: js notranslate">var cube = new THREE.Mesh(boxGeometry, basicMaterial);
</pre>

<p>...with the newly created <code>shaderMaterial</code>:</p>

<pre class="brush: js notranslate">var cube = new THREE.Mesh(boxGeometry, shaderMaterial);
</pre>

<p>Three.js compiles and runs the shaders attached to the mesh to which this material is given. In our case the cube will have both vertex and texture shaders applied. That's it — you've just created the simplest possible shader, congratulations! Here's what the cube should look like:</p>

<p><img alt="Three.js blue cube demo" src="https://end3r.github.io/MDN-Games-3D/Shaders/img/cube.png" style="display: block; margin: 0px auto;"></p>

<p>It looks exactly the same as the Three.js cube demo but the slightly different position and the same blue color are both achieved using the shader.</p>

<h2 id="Final_code">Final code</h2>

<h3 id="HTML">HTML</h3>

<pre class="brush: html notranslate">&lt;script src="https://end3r.github.io/MDN-Games-3D/Shaders/js/three.min.js"&gt;&lt;/script&gt;
&lt;script id="vertexShader" type="x-shader/x-vertex"&gt;
    void main() {
        gl_Position = projectionMatrix * modelViewMatrix * vec4(position.x+10.0, position.y, position.z+5.0, 1.0);
    }
&lt;/script&gt;
&lt;script id="fragmentShader" type="x-shader/x-fragment"&gt;
    void main() {
        gl_FragColor = vec4(0.0, 0.58, 0.86, 1.0);
    }
&lt;/script&gt;
</pre>

<h3 id="JavaScript">JavaScript</h3>

<pre class="brush: js notranslate">    var WIDTH = window.innerWidth;
    var HEIGHT = window.innerHeight;

    var renderer = new THREE.WebGLRenderer({antialias:true});
    renderer.setSize(WIDTH, HEIGHT);
    renderer.setClearColor(0xDDDDDD, 1);
    document.body.appendChild(renderer.domElement);

    var scene = new THREE.Scene();

    var camera = new THREE.PerspectiveCamera(70, WIDTH/HEIGHT);
    camera.position.z = 50;
    scene.add(camera);

    var boxGeometry = new THREE.BoxGeometry(10, 10, 10);

    var shaderMaterial = new THREE.ShaderMaterial( {
        vertexShader: document.getElementById( 'vertexShader' ).textContent,
        fragmentShader: document.getElementById( 'fragmentShader' ).textContent
    });

    var cube = new THREE.Mesh(boxGeometry, shaderMaterial);
    scene.add(cube);
    cube.rotation.set(0.4, 0.2, 0);

    function render() {
        requestAnimationFrame(render);
        renderer.render(scene, camera);
    }
    render();</pre>

<h3 id="CSS">CSS</h3>

<pre class="brush: css notranslate">body { margin: 0; padding: 0; font-size: 0; }
canvas { width: 100%; height: 100%; }
</pre>

<h3 id="Result">Result</h3>

<p>{{ EmbedLiveSample('Final_code', '100%', '400', '', 'Games/Techniques/3D_on_the_web/GLSL_Shaders') }}</p>

<h2 id="Conclusion">Conclusion</h2>

<p>This article has taught the very basics of shaders. Our example doesn't do much but there are many more cool things you can do with shaders — check out some really cool ones on <a href="http://shadertoy.com/">ShaderToy</a> for inspiration and to learn from their sources.</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://web.archive.org/web/20180624211158/http://learningwebgl.com/blog/?page_id=1217">Learning WebGL</a> — for general WebGL knowledge</li>
 <li><a href="http://webglfundamentals.org/webgl/lessons/webgl-shaders-and-glsl.html">WebGL Shaders and GLSL at WebGL Fundamentals</a> — for GLSL specific information</li>
</ul>
